// Odstrann rychlostnch zvislost. Vsledek na asu sleep nezvis

// Konto udlme monitorem
class Konto { 
	private int konto;   // to je pamt pro vlastn konto

	public Konto(int i){ // konstruktor pro zaloen a inicializaci konta
		konto = i;
	}

	public int stav() {  // nen sychronized
		return konto;
	}
	
	public synchronized void vyber(int kolik) {
		int lokal; // pro zachovn podmnek jako u RZ
		
		try {
			lokal = konto;
			Thread.sleep(100);   
			konto = lokal - kolik;
			//	notify();
		}
		catch (InterruptedException e) {} 
	}
	
	public synchronized void vloz(int kolik) {
		int lokal;
		
		try {
			lokal = konto;
			Thread.sleep(300);
			konto = lokal + kolik;
			//	notify();
		}
		catch (InterruptedException e) {}
	}
}
class Koupe extends Thread { 
	private Konto k;
	
	Koupe(Konto x, String jmeno) { 
		super(jmeno);
		k = x;
	}
	
	public void run() { // vstupn bod vlkna
		System.out.println(getName() + " start."); 
		k.vyber(200); 
		System.out.println(getName() + " ukonen."); 
	} 
} 
class Prodej extends Thread { 
	private Konto k;
	
	Prodej(Konto x, String jmeno) { 
		super(jmeno);
		k = x;
	}
	
	public void run() { // vstupn bod vlkna
		System.out.println(getName() + " start."); 
		k.vloz(500);
		System.out.println(getName() + " ukonen."); 
	} 
}  

class Konta { 
	public static void main (String args[]) throws InterruptedException {
		
		System.out.println("Hlavn vlkno startuje"); 
		Konto meKonto = new Konto(1000);  // vytvm konto, mohu jich udlat i vc
		Koupe nakup = new Koupe(meKonto," nakupuji ");
		Prodej prodej = new Prodej (meKonto, " prodvm "); 
		nakup.start();
		prodej.start(); 
		Thread.sleep(500);                // aby Koupe i Prodej mly as skonit
		System.out.println(meKonto.stav()); 
		System.out.println("Kon hlavn vlkno");
	} 
} 
