// Ukzka pouit wait a notify. Producent ukld do bufferu Queue ten sla, 
// konzument z nj vybr a vypisuje. Hls patn napsan a chce nov. 
// Petenm zpornho sla program kon. Queue je monitorem. Nen vlknem, 
// to je dvod, pro wait, notify jsou metody z Object.
import java.io.*;

//Buffer m podobu kruhov fronty realizovan polem
class Queue {	
	private int [] que;	
	private int nextIn, nextOut, filled, queSize;
	
	public Queue(int size) {
		que = new int [size];
		filled = 0;
		nextIn = 1;
		nextOut = 1;
		queSize = size;	
	} // konec konstruktoru	

	public synchronized void deposit (int item) {  // zamkne objekt
		try {
			while (filled == queSize)
				wait();	                           // odemkne objekt, kdy je fronta pln a ek
			que [nextIn] = item;
			nextIn = (nextIn % queSize) + 1;
			filled++;
			notify();                              // bud vlkno konzumenta a uvoluje monitor
		} //konec try
		catch (InterruptedException e) {
			System.out.println("peruen deposit");
		}
	} //konec deposit

	public synchronized int fetch() {
		int item = 0;
		try {
			while (filled == 0)
				wait();                            // odemkne objekt fronta a ek na vloen
			item = que [nextOut];
			nextOut = (nextOut % queSize) + 1;
			filled--;
			notify();                              // bud vlkno producenta a uvoluje monitor
		} //konec try
		catch(InterruptedException e) {
			System.out.println("peruen fetch");
		}
		return item;
	} //konec fetch
} //konec tridy Queue

// producent te z klvesnice a ukld do bufferu
class Producer extends Thread {
	private Queue buffer;
	
	public Producer(Queue que) {
		buffer = que;              // konstruktor producenta dostane jako parametr frontu
	}
	
	public void run() {
		int new_item = 0; // nepelo bez inicializace
		
		opakuj: while (new_item > -1) { // ukonme -1 nebo zpornm slem 
			try {  // produkce
				byte[] vstupniBuffer = new byte[20];
				System.in.read(vstupniBuffer);
				String s = new String(vstupniBuffer).trim(); // oezn neviditelnch znak
				new_item = Integer.valueOf(s).intValue();    // peveden na integer
			}
			catch (NumberFormatException e) {                // kdy slo nen sprvn zapsan
				System.out.println("nebylo to dobr");
				continue opakuj;
			}
			catch (IOException e) {                          // zachytv nepipravenou. klvesnici
				System.out.println("chyba ten");
			}
			buffer.deposit(new_item);
		}
	}
}

// konzument vybr daj z bufru a tiskne ho
class Consumer extends Thread {
	private Queue buffer;
	
	public Consumer(Queue que) {
		buffer = que;
	}
	
	public void run() {
		int stored_item = 0;	             // chce inicializaci
		while (stored_item > -1) {           // ukoncime -1 nebo zpornm slem
			stored_item = buffer.fetch();    // konzument vybr buffer
			System.out.println(stored_item); // konzumace
		}
	}
}

public class P_C {
	public static void main(String [] args) {
		Queue buff1 = new Queue(100);
		Producer producer1 = new Producer(buff1);
		Consumer consumer1 = new Consumer(buff1);
		producer1.start();
		consumer1.start();
	}
}