// Skupiny vlken a dmoni
import java.io.IOException;

public class Demon implements Runnable 
{
	private static Thread mainThread;

	private int counter = 0;

	public static void main(String[] args)
	{
		mainThread = Thread.currentThread();
		System.out.println("Hlavn zan, skupina = " + mainThread.getThreadGroup());
		Demon d = new Demon();
		d.init();
	}

	public void init()
	{
		try
		{
			// Vytvo novou ThreadGroup rodicGroup a jejho potomka
			ThreadGroup rodicGroup = new ThreadGroup("rodi ThreadGroup");

			ThreadGroup potomekGroup = new ThreadGroup(rodicGroup, "potomek ThreadGroup");

			// Vytvo a odstartuje druh vlkno			
			Thread vlakno2 = new Thread(rodicGroup, this);
			System.out.println("Startuje " + vlakno2.getName() + "...");
			vlakno2.start();

			// Vytvo a odstartuje tet vlkno, kter je typu daemon
			Thread vlakno3 = new Thread(potomekGroup, this);
			System.out.println("Startuje " + vlakno3.getName() + "...");
			vlakno3.setDaemon(true);
			vlakno3.start();

			// Vype poet aktivnch vlken ve skupin rodicGroup
			System.out.println("Aktivnch vlken ve skupin " +rodicGroup.getName() + " = " + rodicGroup.activeCount());

			System.out.println("Hlavn - mm teda skonit (ENTER) ?");
			System.in.read();
			System.out.println("Enter.....");


			System.out.println("Hlavn kon");
			return;
		}
		catch (IOException e)
		{
			System.out.println(e);
		}
	}

	// Implementace Runnable.run()
	public void run()
	{
		long max = 10;
		if (Thread.currentThread().getName().equals("Thread-1"))
			max *= 2; 
		for (int i = 0; i < max; i++)
		{
			try {
				System.out.println(Thread.currentThread().getName() + ": " + i);
				Thread.sleep(500);
			}
			catch (InterruptedException ex)
			{
				System.out.println(ex.toString());
			}
			counter++;
		}
		System.out.println("Hlavn alive:" + mainThread.isAlive());

		System.out.println(Thread.currentThread().getName() + " skonilo vpoet.");
	}	
}
