// V pkladu je dna celoseln matice a chceme sest vechny jej prvky. 
// V multiprocesorovm prosted bude vhodn rozdlit ji na sti, stat je samostatn 
// a pak sest vsledky. Bariera zabrn seten parcilnch sout ped jejich kompletac.

import java.util.concurrent.*;   

public class Soucet {

	private static int matrix[][] = {
			{1, 1, 1, 1, 1},
			{2, 2, 2, 2, 2},
			{3, 3, 3, 3, 3},
			{4, 4, 4, 4, 4},
			{5, 5, 5, 5, 5}
	};

	private static int results[];   

	// Jej instance provedou sten souty
	private static class Summer extends Thread {
		int row;
		CyclicBarrier barrier;                    // Vlkna tto tdy pracuj s barirou

		Summer(CyclicBarrier barrier, int row) {  // To je konstruktor sumtoru
			this.barrier = barrier;
			this.row = row;
		}

		// aktivita vlkna pro sten souet
		public void run() {
			int columns = matrix[row].length;     // dky pipout rzn poty sloupc
			int sum = 0;

			for (int i=0; i<columns; i++) {       // proveden stenho soutu dku row
				sum += matrix[row][i];
			}
			results[row] = sum;
			System.out.println(
					"Vsledek pro dek " + row + " je : " + sum);
			try {
				barrier.await();                  // ekn na ostatn astnky
			} catch (InterruptedException ex) {
				ex.printStackTrace();
			} catch (BrokenBarrierException ex) {
				ex.printStackTrace();
			}
		}
	}  // konec Summer = sumtoru pro sten souty

	public static void main(String args[]) {
		final int rows = matrix.length; 
		results = new int[rows];

		Runnable merger = new Runnable() {       // Definice barirov akce, splynut stenho soutu

			public void run() {
				int sum = 0;

				for (int i=0; i<rows; i++) {
					sum += results[i];          // kter sete sten souty
				}
				System.out.println("Celkov vsledek je " + sum);
			}
		};

		// Vytvoen bariry
		// rows = poet astnk, tj. dek, merger je barirov akce
		CyclicBarrier barrier = new CyclicBarrier(rows, merger);

		// Vytvoen a sputn vlken pro sten souty. 
		// Konstruktor Summer d kadmu vlknu bariru barier a slo dky
		for (int i=0; i<rows; i++) {             
			new Summer(barrier, i).start();
		}
		System.out.println("ekn, kdy nen k tisku zatm dn souet");
	}
}

