// Draba. 100 zkaznk chce nakupovat. Cenu uruj prodavai-odhadci jsou jen 2 
// (uren ceny je simulovan Random), take vem zkaznkm nestihnou odhadnout 
// nebo je cena jednotn = mn vhodn. Za jednotnou mus kupovat ti zkaznci, 
// kte se nedostali k odhadci.

import java.util.concurrent.*;
import java.util.*;   

public class SemaforTest {
	private static final int LOOP_COUNT = 100;     // 100 zkaznk
	private static final int MAX_AVAILABLE = 2;    // dva prodavai
	private final static Semaphore semaphore = new Semaphore(MAX_AVAILABLE, true);   

	// uren ceny ...
	private static class Pricer {
		private static final Random random = new Random();
		
		// ... odhadcem
		public static int getGoodPrice() {
			int price = random.nextInt(100);
			try {
				Thread.sleep(1);                 // urit cenu trv njak as
			} catch (InterruptedException ex) {
				ex.printStackTrace();
			}
			return price;                         // cena uren odhadcem
		}
		
		public static int getBadPrice() {
			return 100;                           // nevhodn jednotn cena
		}
	}

	public static void main(String args[]) {
		
		// vytvoen a sputn 100 vlken = zkaznk
		for (int i = 0; i < LOOP_COUNT; i++) {
			final int count = i;
			
			new Thread() {
				public void run() {
					int price;
					
					if (semaphore.tryAcquire()) {              // prodava je voln, ur cenu
						try {
							price = Pricer.getGoodPrice();
						} finally {
							semaphore.release();               // uvolnn prodavae
						}
					} else {
						price = Pricer.getBadPrice();          // prodava nen voln, pak nhradn een
					}
					System.out.println(count + ": " + price);  // tisk sla zkaznka a cena
				}
			}.start();
		}
	}
}

