// Pklad vytvo mnoinu vlken, nedovol ale dnmu bet dokud nejsou vechna vlkna vytvoena. 
// Vlkno main ek na zvoe a skon vech 10 vlken.
// Tento pklad by se dal esit i jinak, teba joinem.

import java.util.concurrent.*;   

public class ZavoraTest {
	private static final int COUNT = 10;

	private static class Worker implements Runnable {  // tda Worker ma dv zvory
		CountDownLatch startLatch;
		CountDownLatch stopLatch;
		String name;

		// konstruktor s formlnmi jmny zvor
		Worker(CountDownLatch startLatch, CountDownLatch stopLatch, String name) {
			this.startLatch = startLatch;
			this.stopLatch = stopLatch;
			this.name = name;
		}

		public void run() {	// Metoda run tdy Worker

			try {
				startLatch.await();	// STOP: tady se hned vlkna zastav a pob a po START
			} catch (InterruptedException ex) {
				ex.printStackTrace();
			}
			System.out.println("B: " + name);
			stopLatch.countDown();	// dekrementace tae zvory na konci vlkna
		}
	}       

	public static void main(String args[]) {

		CountDownLatch startSignal = new CountDownLatch(1);      // vytvoen zvory s taem
		CountDownLatch stopSignal  = new CountDownLatch(COUNT);  // ta stopsignal je 10

		// Vytvo 10 vlken a spust je, ty se ale v mste STOP hned zastav.
		// Jmena vlken jsou 0, 1, .., 9.
		for (int i=0; i<COUNT; i++) {
			new Thread(new Worker(startSignal, stopSignal, Integer.toString(i))).start(); 	
		}
		System.out.println("Dlej");	// Provede se po vytvoen vech 10 vlken
		startSignal.countDown();		// START: startSignal zvora se vynuluje
		try {
			stopSignal.await();	        // vlkno main ek, a vech 10 vlken skon
		} catch (InterruptedException ex) {
			ex.printStackTrace();
		}
		System.out.println("Hotovo");
	}
}
